﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.2
@EndOfDesignText@
'B4A=True
'Group=Default Group
'ModulesStructureVersion=1
'Type=Class
'Version=10.6
'@EndOfDesignText@

Sub Class_Globals
	
	Type TMapShapeCircle(fLatLng As TMapLatLng, _
						 fRadius As Double, _
						 fColor As Int, _
						 fFilled As Boolean, _
						 StrokeWidth As Double, _
						 fData As Object)
	Private fShape As TMapShapeCircle
	Private fcvMap As cvMap
	Private mLayer As Int 'added RBS 02/05/2022

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(aCVMap As cvMap, aShape As TMapShapeCircle)
	fcvMap = aCVMap
	fShape = aShape
	mLayer = MapUtilities.iCircleLayer 'added RBS 02/05/2022
End Sub

'draw the shape
Public Sub Draw
	Dim p As TMapPoint = fcvMap.LatLngToPoint(fShape.fLatLng)
	fcvMap.shapeCanvas.DrawCircle(p.fX, p.fY, fShape.fRadius, fShape.fColor, fShape.fFilled, fShape.StrokeWidth)
	'Log("clsMapShapeCircle, draw, fShape.fLatLng: " & fShape.fLatLng.fLat & ", " & fShape.fLatLng.fLng)
End Sub

'return true if point is in shape
Public Sub PointInShape(aPoint As TMapPoint) As Boolean
	Dim c As TMapPoint = fcvMap.LatLngToPoint(fShape.fLatLng)
	Return MapUtilities.distanceBetween2Points(c, aPoint) <= fShape.fRadius
End Sub

'get shape
Public Sub get_Shape As TMapShapeCircle
	Return fShape
End Sub

'set shape
Public Sub set_Shape(aShape As TMapShapeCircle)
	fShape = aShape
End Sub

'return shape type
Public Sub getShape_Type As String
	Return "circle"
End Sub

'return shape data
Public Sub getShape_Data As Object
	Return fShape.fData
End Sub

'added RBS 02/05/2022
Public Sub getlayer As Int
	Return mLayer
End Sub

Public Sub setlayer(iLayer As Int)
	mLayer = iLayer
End Sub