﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.2
@EndOfDesignText@
'B4A=True
'Group=Default Group
'ModulesStructureVersion=1
'Type=Class
'Version=10.6
'@EndOfDesignText@

Sub Class_Globals
	Type TMapShapeImage(fLatLng As TMapLatLng,fBitmap As B4XBitmap,fRotation As Double,fData As Object)
	Private fcvMap As cvMap
	Private fShape As TMapShapeImage
	Private mLayer As Int 'added RBS 02/05/2022
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(aCVMap As cvMap,aShape As TMapShapeImage)
	fcvMap = aCVMap
	fShape = aShape
	mLayer = MapUtilities.iImageLayer 'added RBS 02/05/2022
End Sub

'draw the shape
Public Sub Draw
	'Log("draw image")
	Dim pt As TMapPoint=fcvMap.LatLngToPoint(fShape.fLatLng)
	Dim r As B4XRect
	r.Initialize(pt.fX-fShape.fBitmap.Width/2, _   'Left
				 pt.fY-fShape.fBitmap.Height/2, _  'Top
				 pt.fX+fShape.fBitmap.Width/2, _   'Right
				 pt.fY+fShape.fBitmap.Height/2)    'Bottom
	'Log(r.Bottom)
	fcvMap.ShapeCanvas.DrawBitmapRotated(fShape.fBitmap,r,fShape.fRotation)
End Sub

'return true if point is in shape
Public Sub PointInShape(aPoint As TMapPoint) As Boolean
	Dim pt As TMapPoint = fcvMap.LatLngToPoint(fShape.fLatLng)
	Dim r As B4XRect
	'this was faulty, has been corrected
	r.Initialize(pt.fX-fShape.fBitmap.Width/2, pt.fY-fShape.fBitmap.Height/2, pt.fX+fShape.fBitmap.Width/2, pt.fY + fShape.fBitmap.Height/2)
	Return MapUtilities.PointInRect(aPoint, r)
End Sub

'get shape
Public Sub get_Shape As TMapShapeImage
	Return fShape
End Sub

'set shape
Public Sub set_Shape(aShape As TMapShapeImage)
	fShape=aShape
End Sub

'return shape type
Public Sub getShape_Type As String
	Return "image"
End Sub

'return shape data
Public Sub getShape_Data As Object
	Return fShape.fData
End Sub

'added RBS 02/05/2022
Public Sub getlayer As Int
	Return mLayer
End Sub

Public Sub setlayer(iLayer As Int)
	mLayer = iLayer
End Sub